/// <reference types="node" />
import { Env } from "./types";
import FunctionTable from "./function-table";
import GlobalOffsetTable from "./global-offset-table";
export default class DlopenManger {
    private dlerrorPtr;
    private _malloc?;
    private _free?;
    private memory;
    private functionTable;
    private globalOffsetTable;
    private pathToLibrary;
    private handleToLibrary;
    private readFileSync;
    private importObject;
    private mainGetFunction;
    private importWebAssemblySync;
    private getMainInstanceExports;
    constructor(getFunction: (name: string, path?: string) => Function | null | undefined, memory: WebAssembly.Memory, globalOffsetTable: GlobalOffsetTable, functionTable: FunctionTable, readFileSync: (path: string) => Buffer, importObject: {
        env?: Env;
        wasi_snapshot_preview1?: any;
    }, importWebAssemblySync: (path: string, importObject: object) => WebAssembly.Instance, getMainInstanceExports: () => {
        [key: string]: any;
    });
    add_dlmethods(env: Env): void;
    getState(): Set<string>;
    setState(state: any): void;
    private malloc;
    private free;
    dlopenEnvHandler(path: string): (env: any, key: string) => any;
    private symbolViaPointer;
    dlopen(pathnamePtr: number, _flags: number): number;
    dlsym(handle: number, symbolPtr: number): number;
    dladdr(): number;
    dlclose(handle: number): number;
    set_dlerror(s: string): void;
    dlerror(): number;
    getFunction(name: string): Function | null | undefined;
}
